/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2006 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#include "stdafx.h"
#include "GhostButton.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

GhostButton::GhostButton() :
	pTitleTexture(NULL),
	pBottomTexture(NULL),
	pEntryTexture(NULL),
	pActiveEntryTexture(NULL),
	pFolderTexture(NULL),
	pActiveFolderTexture(NULL),
	pInfoTexture(NULL),
	pActiveInfoTexture(NULL),
	pSeparatorTexture(NULL)
{
	pTitleTexture = Create_xTextureClass();
	pBottomTexture = Create_xTextureClass();
	pEntryTexture = Create_xTextureClass();
	pActiveEntryTexture = Create_xTextureClass();
	pFolderTexture = Create_xTextureClass();
	pActiveFolderTexture = Create_xTextureClass();
	pInfoTexture = Create_xTextureClass();
	pActiveInfoTexture = Create_xTextureClass();
	pSeparatorTexture = Create_xTextureClass();
}

GhostButton::~GhostButton()
{
	if (pTitleTexture)
		Destroy_xTextureClass(pTitleTexture);
	if (pBottomTexture)
		Destroy_xTextureClass(pBottomTexture);
	if (pEntryTexture)
		Destroy_xTextureClass(pEntryTexture);
	if (pActiveEntryTexture)
		Destroy_xTextureClass(pActiveEntryTexture);
	if (pFolderTexture)
		Destroy_xTextureClass(pFolderTexture);
	if (pActiveFolderTexture)
		Destroy_xTextureClass(pActiveFolderTexture);
	if (pInfoTexture)
		Destroy_xTextureClass(pInfoTexture);
	if (pActiveInfoTexture)
		Destroy_xTextureClass(pActiveInfoTexture);
	if (pSeparatorTexture)
		Destroy_xTextureClass(pSeparatorTexture);

	pTitleTexture = NULL;
	pBottomTexture = NULL;
	pEntryTexture = NULL;
	pActiveEntryTexture = NULL;
	pFolderTexture = NULL;
	pActiveFolderTexture = NULL;
	pInfoTexture = NULL;
	pActiveInfoTexture = NULL;
	pSeparatorTexture = NULL;
}
