/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2005 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#include "stdafx.h"
#include "NotifyDirCheck.h"

//////////////////////////////////////////////////////////////////////
// Work Thread 
//////////////////////////////////////////////////////////////////////

UINT NotifyDirThread( LPVOID pParam )
{
	BOOL             bStop = FALSE;
	HANDLE           hDir  = NULL; 
	CNotifyDirCheck* pNDC  = (CNotifyDirCheck*) pParam;

	if( pNDC == NULL )
		return 0;

	hDir = FindFirstChangeNotification( pNDC->GetDirectory(),
										FALSE,
										FILE_NOTIFY_CHANGE_FILE_NAME  |
										FILE_NOTIFY_CHANGE_DIR_NAME
										 );

	if( hDir == INVALID_HANDLE_VALUE )
		return 0;
	
 	while( pNDC->IsRun() )
	{
		bStop = FALSE;

		while( WaitForSingleObject( hDir, WAIT_TIMEOUT ) != WAIT_OBJECT_0 )
		{	
			if( !pNDC->IsRun() )
			{
				bStop = TRUE;//to end
				break;
			}
		}
		if( bStop )
			break;//to end

		// get rid of all similar events that occur shortly after this
		DWORD dwMilSecs = 250; // arbitrary; enlarge for floppies
		DWORD wr = 0;
		do 
		{
			FindNextChangeNotification(hDir);
			wr = WaitForSingleObject(hDir, dwMilSecs);
		} 
		while (wr == WAIT_OBJECT_0);
		// now wr == WAIT_TIMEOUT, no more pending events

		Sleep( WAIT_TIMEOUT );

		Popup* popup = pNDC->GetPopup();

		if ( popup != NULL )
			popup->ScanSubMenu("", -100, "");

		if( FindNextChangeNotification( hDir ) == 0 )
			return 0;
	}
	
	return FindCloseChangeNotification( hDir );
}

//////////////////////////////////////////////////////////////////////
// Class 
//////////////////////////////////////////////////////////////////////

CNotifyDirCheck::CNotifyDirCheck()
{
	SetPopup( NULL );
	SetDirectory( "" );
	SetStop();
	m_pThread = NULL;
}

CNotifyDirCheck::~CNotifyDirCheck()
{
	Stop();
}

BOOL CNotifyDirCheck::Run()
{
	if( IsRun() || m_pThread != NULL || m_csDir.IsEmpty() )
		return FALSE;

	SetRun();
	m_pThread = AfxBeginThread( NotifyDirThread, this );
	
	if( m_pThread == NULL )
	{
		SetPopup( NULL ); 
		SetStop();
	}

	return IsRun();
}

void CNotifyDirCheck::Stop()
{
	if( !IsRun() || m_pThread == NULL )
		return;
	
	SetPopup( NULL ); 
	SetStop();

	WaitForSingleObject( m_pThread->m_hThread, 2 * NOTIFICATION_TIMEOUT );
	m_pThread = NULL;
}

